#include "stdinc.h"

static WTWFUNCTIONS*				wtw = NULL;
static HWND							hMain = NULL;
static std::vector<std::wstring>	tabs;

static WTW_PTR onClick(WTW_PARAM lParam, WTW_PARAM wParam, void* ptr)
{
	//wtwPanelEvent* panEvent = reinterpret_cast<wtwPanelEvent*>(lParam);
	SendMessage(hMain, WM_COMMAND, reinterpret_cast<WPARAM>(ptr), NULL);
	return 0;
}

extern "C" {

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved)
{
	return 1;
}

WTWPLUGINFO* __stdcall queryPlugInfo(DWORD /*apiVersion*/, DWORD /*masterVersion*/) 
{
	static WTWPLUGINFO plugInfo = {
			sizeof(WTWPLUGINFO),						// struct size
			L"wtwTabs",									// plugin name
			L"Zakadki na licie kontaktw",			// plugin description
			L" 2010 Maciej Muszkowski",				// copyright
			L"Maciej Muszkowski",						// author
			L"maciek.muszkowski@gmail.com",				// authors contact
			L"http://www.alset.pl",						// authors webpage
			L"",										// url to xml with autoupdate data
			PLUGIN_API_VERSION,							// api version
			MAKE_QWORD(1, 0, 0, 0),						// plugin version
			WTW_CLASS_UTILITY,							// plugin class
			NULL,										// function called after "O wtyczce..." pressed
			L"{8d02f838-2342-4505-bf58-c21c1d07c8df}",	// guid
			NULL,										// dependencies (list of guids)
			0, 0, 0, 0									// reserved
	};
	return &plugInfo;
}

int __stdcall pluginLoad(DWORD /*callReason*/, WTWFUNCTIONS* fn) 
{	
	wtw = fn;

	hMain = reinterpret_cast<HWND>(wtw->fnCall(WTW_GET_MAIN_HWND, NULL, NULL));

	HMENU hMenu = GetSubMenu(GetMenu(hMain),1);
	MENUITEMINFO menuInfo;
	memset(&menuInfo, 0, sizeof(MENUITEMINFO));
	menuInfo.cbSize = sizeof(MENUITEMINFO);
	menuInfo.fMask = MIIM_STRING | MIIM_ID;

	wtwPanelDef pan;
	pan.callback = onClick;
	pan.flags = WTW_PANEL_FLAG_AS_BUTTON;
	pan.panelIcon = new wchar_t[128];

	int i = 7;
	while(GetMenuItemInfo(hMenu, i, TRUE, &menuInfo) == TRUE)
	{
		if(menuInfo.cch++==0) // if sep
			break;
		menuInfo.dwTypeData = new wchar_t[menuInfo.cch+1];
		GetMenuItemInfo(hMenu, i, TRUE, &menuInfo);
		pan.panelId = menuInfo.dwTypeData;
		//pan.panelText = menuInfo.dwTypeData;
		pan.panelHint = menuInfo.dwTypeData;
		GetPrivateProfileStringW(L"icons", menuInfo.dwTypeData, WTW_GRAPH_ID_USER, const_cast<wchar_t*>(pan.panelIcon), 127, L"C:\\wtwTabs.ini");
		pan.cbData = reinterpret_cast<void*>(menuInfo.wID);
		wtw->fnCall(WTW_PANEL_ADD, reinterpret_cast<WTW_PARAM>(&pan), NULL);
		tabs.push_back(menuInfo.dwTypeData);
		delete [] menuInfo.dwTypeData;
		menuInfo.dwTypeData = NULL;
		i++;
	}
	delete [] pan.panelIcon;

	return 0;
}

int __stdcall pluginUnload(DWORD /*callReason*/) 
{
	wtwPanelDef pan;
	for(unsigned int i=0;i<tabs.size();i++)
	{
		pan.panelId = tabs[i].c_str();
		wtw->fnCall(WTW_PANEL_DEL, reinterpret_cast<WTW_PARAM>(&pan), NULL);
	}
	return 0;
}

} // extern "C"
